<script lang="ts" setup>
  import { ProductFilteringControlKey } from '~/helpers/injection';

  const emits = defineEmits<{
    (e: 'change', params: { add: string[]; remove: string[] }): void;
    (e: 'add', params: { [k: string]: boolean }): void;
    (e: 'remove', params: { [k: string]: boolean }): void;
  }>();

  const props = defineProps<{
    defaultValue: { [k: string]: boolean };
    cache?: { add: string[]; remove: string[] };
    showBookmarkShortcut?: boolean;
    multipleSelection: boolean;
  }>();

  const leftSidebarController = useLeftSidebar();
  const productsFilteringModal = useModal();
  const selectedProductIds = ref<{ [k: string]: boolean }>({});

  onMounted(() => {
    if (props.cache) {
      let temp: any = {};
      const cacheAdd = props.cache.add.reduce((acc: any, curr) => {
        acc[curr] = true;
        return acc;
      }, {});
      temp = {
        ...props.defaultValue,
        ...cacheAdd,
      };
      props.cache.remove.forEach((key: string) => {
        delete temp?.[key];
      });
      selectedProductIds.value = temp;
    } else {
      selectedProductIds.value = { ...props.defaultValue };
    }
    productsFilteringModal.open();
  });

  watch(leftSidebarController.isOpen, (open) => {
    if (!open) {
      productsFilteringModal.close();
    }
  });

  const handleAdd = (ids: { [k: string]: boolean }) => {
    const temp = Object.keys(selectedProductIds.value)
      .filter((x) => selectedProductIds.value[x])
      .reduce((acc: { [k: string]: boolean }, curr: string) => {
        acc[curr] = true;
        return acc;
      }, {});
    selectedProductIds.value = {
      ...ids,
      ...temp,
    };
    emits('add', ids);
  };

  const handleRemove = (ids: { [k: string]: boolean }, soft = false) => {
    let temp;
    if (!soft) {
      temp = Object.keys(selectedProductIds.value)
        .filter((x) => x)
        .reduce((acc: { [k: string]: boolean }, curr: string) => {
          acc[curr] = true;
          return acc;
        }, {});
    } else {
      temp = { ...selectedProductIds.value };
    }
    for (const key in ids) {
      if (!soft) {
        delete temp?.[key];
      } else {
        temp[key] = false;
      }
    }
    selectedProductIds.value = temp;
    emits('remove', ids);
  };

  const handleRemoveAll = () => {
    selectedProductIds.value = {};
  };

  provide(ProductFilteringControlKey, {
    add: handleAdd,
    remove: handleRemove,
    removeAll: handleRemoveAll,
    showBookmarkShortcut: props.showBookmarkShortcut,
  });

  watch(selectedProductIds, (v) => {
    const trueKey: string[] = Object.keys(v).filter((x) => v[x]);
    const productCanBeAdd = trueKey.filter((x) => !props.defaultValue?.[x]);
    const productCanBeRemove = Object.keys(props.defaultValue ?? {}).filter(
      (x) => !v[x] && props.defaultValue?.[x],
    );
    const result = {
      add: productCanBeAdd,
      remove: productCanBeRemove,
    };
    emits('change', result);
  });
</script>

<template>
  <ProductsFilteringController
    :value="selectedProductIds"
    :modal-controller="productsFilteringModal"
    :multiple-selection="multipleSelection"
  />

  <ProductsFilteringModal
    v-if="productsFilteringModal.isOpen"
    :controller="productsFilteringModal"
    :value="selectedProductIds"
    :multiple-selection="multipleSelection"
  >
    <template #select-button="data">
      <slot name="select-button" v-bind="data" />
    </template>
  </ProductsFilteringModal>
</template>
